<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 01/07/14
 * Time: 14:03
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Logic;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;


class ProcessQueue {

    const QUEUE_QUERY="INSERT INTO TKU_PROCESS_QUEUE (TKU_PROCESS_QUEUE_ID, NRORG, NAME, TKU_PROCESS_ID, STATUS, PROCESS_PARAMS, PRIORITY, MINUTOS_EXEC, HORAS_EXEC, DIAS_MES_EXEC, MESES_EXEC, DIAS_SEM_EXEC, CDOPERADOR)
VALUES (:P_ID, :P_NRORG, :P_NAME, :P_TYPE, :P_STATUS, :P_PARAMS, :P_PRIORITY, :P_MINUTOS, :P_HORAS, :P_DIAS_MES, :P_MESES, :P_DIAS_SEM, :P_OPERADOR)";

    private $name;
    private $nrorg;
    private $type;
    private $desc;
    private $parameters=Array();
    private $status;
    private $priority=5;
    private $schedule=Array('H','H','H','H','H');

    public function setDesc($desc)
    {
        $this->desc = $desc;
    }

    public function getDesc()
    {
        return $this->desc;
    }

    public function setNrorg($nrorg)
    {
        $this->nrorg = $nrorg;
    }

    public function getNrorg()
    {
        if(empty($this->nrorg)){
            return \Geral\Util\Ambiente::getNrorgTrabalho();
        }
        else return $this->nrorg;
    }

    public function setStatus($status)
    {
        $this->status = $status;
    }

    public function getStatus()
    {
        return $this->status;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setParameters($parameters)
    {
        $this->parameters = $parameters;
    }

    public function getParameters()
    {
        return $this->parameters;
    }

    public function addParameter($name, $value){
        $this->parameters[$name]=$value;
    }

    public function setPriority($priority)
    {
        $this->priority = $priority;
    }

    public function getPriority()
    {
        return $this->priority;
    }

    public function setSchedule($schedule)
    {
        $this->schedule = $schedule;
    }

    public function getSchedule()
    {
        return $this->schedule;
    }

    public function setType($type)
    {
        $this->type = $type;
    }

    public function getType()
    {
        return $this->type;
    }

    public function getOperador()
    {

        try{
            $operador=\Geral\Util\Ambiente::getCdOperador();
            if (!isset($operador)) $operador="000000000999";
        }
        catch(Exception $e){
            $operador="000000000999";
        }

        return $operador;
    }


    public function saveQueue(){

        $db = \Setforms2\Runtime\Connection::getInstance();

        $nrorg=$this->getNrorg();
        $priority=$this->getPriority();
        $cronArray=$this->getSchedule();
        $name=$this->getName();
        $status=$this->getStatus();
        $type=$this->getType();
        $operador=$this->getOperador();

        $jsonParams=json_encode($this->getParameters());
        $encodedJson=htmlspecialchars($jsonParams);

        $cronString=implode(" ", $cronArray);

//            $procedure=new Procedure("NOVO_CODIGO");
//            $procedure->addParam(new Param("P_CONTADOR","I","TKU_PROCESS_QUEUE","2",100));
//            $procedure->addParam(new Param("P_SEQUENCIAL","O",null,"2",20));
//            $returnArray=$procedure->call();
//            $pk=ltrim(array_pop($returnArray), '0');
            $pk=\Scheduler\Util\GeraId::get("TKU_PROCESS_QUEUE_ID", "TKU_PROCESS_QUEUE", 1, 1);

            $arrayParams=Array(
                'P_ID' => $pk,
                'P_STATUS' => $status,
                'P_NRORG' => $nrorg,
                'P_TYPE'  => $type,
                'P_NAME' => $name,
                'P_PRIORITY' => $priority,
                'P_PARAMS' => $encodedJson,
                'P_MINUTOS' => $cronArray[0],
                'P_HORAS' => $cronArray[1],
                'P_DIAS_MES' => $cronArray[2],
                'P_MESES' => $cronArray[3],
                'P_DIAS_SEM' => $cronArray[4],
                'P_OPERADOR' => $operador
            );

            $ok=$db->execute(self::QUEUE_QUERY, $arrayParams);

            if ($status==="AGENDADO"){
                \Scheduler\Logic\JobDeleter::deleteJob($pk);
                \Scheduler\Logic\Scheduler::criaXML($pk, $cronString);
            }
            return $ok;

    }
}